/*
 * Ejercicio10.java
 *
 * Creado el 8 de octubre de 2007, 20:32
 */


package computacion.practica2;

/**
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio10 {
    
    /**
     * Como puede observarse, el mtodo inicialmente propuesto para calcular
     * los trminos de la sucesin a_n es muy inestable. Tras el cambio
     *   y_n = a_n / 2^{n+1} 
     * llegamos a la frmula
     *   y_{n+1} = (-1 + (1 + y_n * y_n)^{0.5}) / y_n. 
     * Esta frmula es igualmente inestable, pero tras multiplicar por el 
     * conjugado del numerador se obtiene
     *    y_{n+1} = y_n / (1 + (1 + y_n * y_n)^{0.5}),
     * frmula ya estable con la que se constata que la sucesin a_n converge
     * al nmero pi.
     */
    public static void main(String[] args) {
        double a;
        double y;
        double dosn;
        
        System.out.println("Sucesin a_n (clculo directo)");
        a = 4;
        for (int n = 1; n <= 30; n++) {
            System.out.println("a_" + n + " = " + a);
            a = ( Math.sqrt(1 + a * a / Math.pow (2, 2 * n + 2)) - 1 ) /
                    a * Math.pow (2, 2 * n + 3);
        }
        
        System.out.println("");
        System.out.println("Sucesin a_n " +
                "(con el cambio a y_n pero sin multiplicar por el conjugado)");
        y = 1;
        dosn = 4;
        for (int n = 1; n <= 30; n++) {
            a = y * dosn;
            System.out.println("a_" + n + " = " + a);
            y = (-1 + Math.sqrt(1 + y * y)) / y;
            dosn = 2 * dosn;
        }
        
        System.out.println("");
        System.out.println("Sucesin a_n " +
                "(con el cambio a y_n y multiplicando por el conjugado)");
        y = 1;
        dosn = 4;
        for (int n = 1; n <= 30; n++) {
            a = y * dosn;
            System.out.println("a_" + n + " = " + a);
            y = y / (1 + Math.sqrt(1 + y * y));
            dosn = 2 * dosn;
        }        
    }
    
}
