/*
 * SumaArmonica.java
 *
 * Creado el 29 de noviembre de 2005, 11:35
 */


package computacion.practica2;

/**
 * Este ejercicio muestra que el orden en que se realizan las sumas no es 
 * relevante salvo que haya diferencias sustanciales en el tamao de los 
 * sumandos. En este caso, de hecho, la suma descendente (que es la 
 * recomendable) da una error ligeramente superior a la ascendente, pero la 
 * diferencia es fruto del azar en el redondeo. 
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class SumaArmonica {
    
    public static double EULER = 0.57721566490153286;
    
    public static void main(String[] args) {
        System.out.println("Iteracion\t" + "Sumas ascendentes\t" 
                + "Errores relativos ");
        System.out.println("n = 1000:\t" + sumaAscendente(1000) + "\t"
                + errorRelativo(EULER, sumaAscendente(1000) - Math.log(1000)));
        System.out.println("n = 2000:\t" + sumaAscendente(2000) + "\t"
                + errorRelativo(EULER, sumaAscendente(2000) - Math.log(2000)));
        System.out.println("n = 4000:\t" + sumaAscendente(4000) + "\t"
                + errorRelativo(EULER, sumaAscendente(4000) - Math.log(4000)));
        
        System.out.println();
        System.out.println("Iteracin\t" + "Sumas descendentes\t" 
                + "Errores relativos ");
        System.out.println("n = 1000:\t" + sumaDescendente(1000) + "\t"
                + errorRelativo(EULER, sumaDescendente(1000) - Math.log(1000)));
        System.out.println("n = 2000:\t" + sumaDescendente(2000) + "\t"
                + errorRelativo(EULER, sumaDescendente(2000) - Math.log(2000)));
        System.out.println("n = 4000:\t" + sumaDescendente(4000) + "\t"
                + errorRelativo(EULER, sumaDescendente(4000) - Math.log(4000)));
    }
    
    public static double sumaAscendente(int n) {
        double suma = 0;
        
        for (int j = 1; j <= n; j++) {
            suma = suma + 1. / j;
        }
        return suma;
    }
    
    public static double sumaDescendente(int n) {
        double suma = 0;
        
        for (int j = n; j >= 1; j--) {
            suma = suma + 1. / j;
        }
        return suma;
    }
    
    public static double errorRelativo(double real, double aprox) {
        return Math.abs(real - aprox) / Math.abs(real);
    }
}
