/*
 * Ejercicio7.java
 *
 * Creado el 29 de noviembre de 2007, 13:08
 */


package computacion.practica3;
import auxiliar.*;

/**
 * En este caso la convergencia es ms rpida que la lineal y ms lenta que la
 * cuadrtica: los cocientes se van muy rpido a cero si p = 1, comienzan a 
 * crecer si p = 2, y se mantiene con tamaos razonables si p = (1 + 5^{1/2})/2,
 * que es el orden de convergencia para el mtodo de la secante.
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio7 {
    
    public static void main(String[] args) {
        double xini = -30000;
        double xfin = 30000;
        double raiz;
        double aux;
        double p;
        FuncionEj7 f = new FuncionEj7();
        
        try {
            raiz = MetodosIterativos.secante(f, xini, xfin, 1E-16, 100);            
            System.out.println("x_0 = " + xini);
            System.out.println("x_1 = " + xfin);
            System.out.println("Raz: " + raiz);
            
            System.out.println();
            System.out.println("No existe convergencia lineal:");
            p = 1;            
            for (int i = 0; i <= 8; i++) {
                System.out.println( "|x_" + (i + 1) + " - raz| / "
                        + "|x_" + i + " - raz| = " 
                        + (Math.abs(xfin - raiz) /
                        Math.pow(Math.abs(xini - raiz), p)) );                
                aux = xfin - f.eval(xfin) * (xfin - xini)
                        / (f.eval(xfin) - f.eval(xini));
                xini = xfin;
                xfin = aux;                
            }    
            
            System.out.println();
            System.out.println("No existe convergencia cuadrtica:");
            p = 2;
            xini = -30000;
            xfin = 30000;            
            for (int i = 0; i <= 8; i++) {
                System.out.println( "|x_" + (i + 1) + " - raz| / "
                        + "|x_" + i + " - raz|^2 = " 
                        + (Math.abs(xfin - raiz) /
                        Math.pow(Math.abs(xini - raiz), p)) );                
                aux = xfin - f.eval(xfin) * (xfin - xini)
                        / (f.eval(xfin) - f.eval(xini));
                xini = xfin;
                xfin = aux;                
            }     
            
            System.out.println();
            System.out.println("Convergencia de orden p = (1 + 5^{1/2})/2:");
            p = (1 + Math.sqrt(5)) / 2;
            xini = -30000;
            xfin = 30000;                        
            for (int i = 0; i <= 8; i++) {
                System.out.println( "|x_" + (i + 1) + " - raz| / "
                        + "|x_" + i + " - raz|^p = " 
                        + (Math.abs(xfin - raiz) /
                        Math.pow(Math.abs(xini - raiz), p)) );                
                aux = xfin - f.eval(xfin) * (xfin - xini)
                        / (f.eval(xfin) - f.eval(xini));
                xini = xfin;
                xfin = aux;                
            }     
        } catch(MetodosIterativos.ErrorMetodosIterativos err) {
        }
    }
    
}
