/*
 * Ejercicio4.java
 *
 * Creado el 18 de diciembre de 2007, 22:02
 */


package metodosLineales.practica6;
import auxiliar.*;

/**
 * Esta prctica gira en torno a las matrices de Hilbert, que estn muy
 * mal condicionadas. Sin embargo es conocido que sus inversas pueden
 * calcularse explcitamente (de hecho tienen coeficientes enteros) lo que 
 * permite usarlas paracomparar la eficacia de los distintos mtodos de 
 * resolucin de sistemas de ecuaciones. En este caso vemos que el mtodo QR da a
 * la larga resultados claramente mejores que el de Gauss.
 *
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio4 {
    
    public static void main(String[] args) {
         double[][] Hn;
         double[] soln;
         double[] un;
         
         for (int n = 2; n <= 12; n++) {
            try {
                Hn = new double[n][n];
                soln = new double[n];
                un = new double[n];
              
                for (int i = 0; i < n; i++) {
                    un[i] = 1;
                    for (int j = 0; j < n; j++) {
                        Hn[i][j] =  1. / (i + j + 1);
                    }
                }
             
                soln = Matrices.producto(invHilbert(n), un);                
                System.out.println("Dimensin " + n); 
                System.out.println("Nmero de condicin de la matriz de Hilbert: "
                        + (Matrices.norma1(Hn) * Matrices.norma1(invHilbert(n)))                        
                        );
                System.out.println("Solucin exacta:");
                System.out.println(Matrices.toString(soln));
                System.out.println("Solucin por el mtodo QR:");
                System.out.println(Matrices.toString(
                        Matrices.solucionFactorQR(Hn, un)) );
                System.out.println("Solucin por Gauss Parcial:");
                System.out.println(Matrices.toString(
                        Matrices.gaussParcial(Hn, un)) );
                System.out.println("");
             
            } catch(Matrices.ErrorMetodosLineales err) {                
            }
         }
           
    }
    
    /* Mtodo recursivo para calcular el nmero combinatorio n sobre m */
    public static int comb(int n, int m) {
        if ((m == 0) || (m == n)) {
            return 1;
        } else {
            return comb(n - 1, m - 1) + comb(n - 1, m);
        }
    }
    
    /* Mtodo para calcular directamente la inversa de la matriz de Hilbert */
    public static double[][] invHilbert(int n) {
        double[][] InvHn = new double[n][n];
       
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                InvHn[i][j] = Math.pow(-1, i + j) * (i + j + 1)
                        * comb(n + i, n - 1 - j) * comb(n + j, n - 1 - i)
                        * comb(i + j, i) * comb(i + j, i);
            }
        }
        return InvHn;
    }
    
}
